import java.awt.Color;
import javax.swing.*;
import java.util.*;

public class Balls {

    public static void nap(int ms) {
	try {
	    Thread.sleep(ms);
	}
	catch(InterruptedException e) {
	    //
	    //  Print out the name of the tread that caused this.
	    //
	    System.err.println("Thread "+Thread.currentThread().getName()+
			       " throwed exception "+e.getMessage());
	}
    }

    public static void main(String[] a) {
	
        final BallWorld world = new BallWorld();
	final JFrame win = new JFrame();
	SwingUtilities.invokeLater(new Runnable() {
	    public void run() {
		win.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		win.getContentPane().add(world);
		win.pack();
		win.setVisible(true);
	    }});
	
	Thread.currentThread().setName("MyMainThread");

	Set<Thread> balls = new HashSet<Thread>();
	Thread t;

	nap((int)(5000*Math.random()));
	t = new Ball(world, 50, 80, 5, 10, Color.red);
	balls.add(t);
	t.start();
	nap((int)(5000*Math.random()));
	t = new Ball(world, 70, 100, 8, 6, Color.blue);
	balls.add(t);
	t.start();
	nap((int)(5000*Math.random()));
	t = new Ball(world, 150, 100, 9, 7, Color.green);
	balls.add(t);
	t.start();
	nap((int)(5000*Math.random()));
	t = new Ball(world, 200, 130, 3, 8, Color.black);
	balls.add(t);
	t.start();

	for(Thread kill : balls) {
	    nap((int)(5000*Math.random()));
	    kill.interrupt();
	}
    }
}
